c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1992  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ############################################################
c     ##                                                        ##
c     ##  couple1.i  --  near-neighbor atom connectivity lists   ##
c     ##                                                        ##
c     ##                 within the periodic box only
c     ############################################################
c
c
c     maxn13   maximum number of atoms 1-3 connected to an atom
c     maxn14   maximum number of atoms 1-4 connected to an atom
c     maxn15   maximum number of atoms 1-5 connected to an atom
c
c     n12      number of atoms directly bonded to each atom
c     i12      atom numbers of atoms 1-2 connected to each atom
c     n13      number of atoms in a 1-3 relation to each atom
c     i13      atom numbers of atoms 1-3 connected to each atom
c     n14      number of atoms in a 1-4 relation to each atom
c     i14      atom numbers of atoms 1-4 connected to each atom
c     n15      number of atoms in a 1-5 relation to each atom
c     i15      atom numbers of atoms 1-5 connected to each atom
c
c
      integer maxn131,maxn141,maxn151
      parameter (maxn131=3*maxval)
      parameter (maxn141=9*maxval)
      parameter (maxn151=27*maxval)
      integer n121,i121,n131,i131,n141,i141,n151,i151
      common /couple1/ n121(maxatm),i121(maxval,maxatm),n131(maxatm),
     &i131(maxn131,maxatm),n141(maxatm),i141(maxn141,maxatm),
     &n151(maxatm),i151(maxn151,maxatm)
