      subroutine imageqq(xr,yr,zr,ia,x1,y1,z1,x2,y2,z2)
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cell.i'
      include 'cross.i'
      include 'atoms.i'
      real*8 xr,yr,zr,pi,dd,dw,dist,f,fcco,
     1xaa,yaa,zaa,ucos,usin,x1,y1,z1,x2,y2,z2,xro,yro,zro
      integer j,ia,it,ib
      logical lcyl
c     temporary approximation:
      ib=ia
c
      pi=4.0d0*atan(1.0d0)
      if (.not.orthogonal) then
       write(6,*)' Only orthogonal allowed for 1D periodicity'
       call fatal
      endif
      xr = x1 - x2
      yr = y1 - y2
      zr = z1 - z2
      xaa=x1
      yaa=y1
      zaa=z1
c
      if(icx.eq.1)then
       call itit(it,xr,xaa,xcell2,xcell)
       call rott(irwp,rwp,it,ia,nper,lper,xcell,ycell,zcell,x,y,z,
     1 yaa,ycell2,zaa,zcell2,cco,yr,zr,y2,z2,cfi,icx,ib)
       call itit(it,yr,yaa,ycell2,ycell)
       call itit(it,zr,zaa,zcell2,zcell)
      endif

      if(icx.eq.2)then
       call itit(it,yr,yaa,ycell2,ycell)
       call rott(irwp,rwp,it,ia,nper,lper,xcell,ycell,zcell,x,y,z,
     1 zaa,zcell2,xaa,xcell2,cco,zr,xr,z2,x2,cfi,icx,ib)
       call itit(it,zr,zaa,zcell2,zcell)
       call itit(it,xr,xaa,xcell2,xcell)
      endif

      if(icx.eq.3)then
       call itit(it,zr,zaa,zcell2,zcell)
       call rott(irwp,rwp,it,ia,nper,lper,xcell,ycell,zcell,x,y,z,
     1 xaa,xcell2,yaa,ycell2,cco,xr,yr,x2,y2,cfi,icx,ib)
       call itit(it,xr,xaa,xcell2,xcell)
       call itit(it,yr,yaa,ycell2,ycell)
      endif

      return
      end
