      function lrottt(i,irwp,rwp,it,init,stop,nper,lper,x,y,z,
     1ucos,usin,xmid,xbox2,ymid,ybox2,zmid,zbox2,
     2cco,kmol,cfi,xf,yf,zf,icx,lwall,mhb,ohb,ihb,xhb,lwdad)
c     rotate molecule, i.e. center and atoms init...stop
      implicit none
      include 'sizes.i'
      integer it,init,stop,nper,lper(*),j,kmol(*),irwp,icx,ihb,xhb(*),
     1mhb(*),i
      real*8 x(*),y(*),z(*),dist,dw,rwp,f,fcco,cco,ucos,usin,arg,fdist,
     1xf,yf,zf,cfi,pi,xbox2,ybox2,zbox2,xmid,ymid,zmid,tol,
     2over,ohb(*)
      logical lcyl,lwall,lrottt,lwdad,lfb
      integer ijob
      common/cjob/ijob

c     totally forbid transfer across the twist:
      lfb=.true.
      
      tol=0.01d0
      pi=4.0d0*atan(1.0d0)
c     is this molecule the central one?:
      do 1 j=1,nper
      lcyl=lper(j).eq.init
1     if(lcyl)goto 2
2     if(lcyl)then
       f=1.0d0
      else
c      this molecule is not the central one, find distance:
       dist=fdist(irwp,rwp,nper,xmid,ymid,zmid,lper,x,y,z,icx)
c      find distance from the box walls:
       if(icx.eq.1)call dww(dw,yf,ybox2,zf,zbox2)
       if(icx.eq.2)call dww(dw,zf,zbox2,xf,xbox2)
       if(icx.eq.3)call dww(dw,xf,xbox2,yf,ybox2)
c      cut-off function:
       f=fcco(dist,cco,dist+dw)

       if(((lwall.and.f.gt.tol.and.f.lt.1.0d0-tol).or.lfb)
     1  .and.ijob.eq.2)then
c       do not rotate nor shift this molecule, but impose a harmonic
c       barrier, so it can get back slowly
        usin=0.0d0
        ucos=1.0d0
        lrottt=.false.
        it=0
        if(icx.eq.1)then
         if(xmid.gt.xbox2)then
          over=xmid-xbox2
         else
          if(xmid.lt.-xbox2)then
           over=xmid+xbox2
          else
           over=0.0d0
           write(6,*)'should not happen',it,xmid
          endif
         endif
        endif
        if(icx.eq.2)then
         if(ymid.gt.ybox2)then
          over=ymid-ybox2
         else
          if(ymid.lt.-ybox2)then
           over=ymid+ybox2
          else
           over=0.0d0
          endif
         endif
        endif
        if(icx.eq.3)then
         if(zmid.gt.zbox2)then
          over=zmid-zbox2
         else
          if(zmid.lt.-zbox2)then
           over=zmid+zbox2
          else
           over=0.0d0
          endif
         endif
        endif
        do 3 j=1,ihb
        if(i.eq.mhb(j))then
c        if it is there, update only:
         ohb(j)=over
         if(lwdad)write(6,*)i,' constraints updated d#d',over
         return
        endif
3       continue
c       if it is not there, add to list:
        ihb=ihb+1
        mhb(ihb)=i
        ohb(ihb)=over
        xhb(ihb)=icx
        if(lwdad)write(6,*)i,' constraints added d#d',over
        return
       endif

      endif
c     rotate along 1D axis:
c     center, previous center, and all atoms:
      if(lwdad)write(6,*)i,' rotated, d#d f = ',f,xmid
      lrottt=.true.
      arg=cfi*pi/180.0d0*dble(it)*f
      usin=sin(arg)
      ucos=cos(arg)
      if(icx.eq.1)then
       call trb(yf       ,zf       ,ucos,usin)
       call trb(ymid     ,zmid     ,ucos,usin)
       do 5 j = init, stop
5      call trb(y(kmol(j)),z(kmol(j)),ucos,usin)
      endif
      if(icx.eq.2)then
       call trb(zf       ,xf       ,ucos,usin)
       call trb(zmid     ,xmid     ,ucos,usin)
       do 6 j = init, stop
6      call trb(z(kmol(j)),x(kmol(j)),ucos,usin)
      endif
      if(icx.eq.3)then
       call trb(xf       ,yf       ,ucos,usin)
       call trb(xmid     ,ymid     ,ucos,usin)
       do 7 j = init, stop
7      call trb(x(kmol(j)),y(kmol(j)),ucos,usin)
      endif
      return
      end
