      subroutine rottt(irwp,rwp,it,init,stop,nper,lper,x,y,z,
     1ucos,usin,xmid,xbox2,ymid,ybox2,zmid,zbox2,
     2cco,kmol,cfi,xf,yf,zf,icx)
c     rotate molecule, i.e. center and atoms init...stop
      implicit none
      include 'sizes.i'
      integer it,init,stop,nper,lper(*),j,kmol(*),irwp,icx
      real*8 x(*),y(*),z(*),dist,dw,rwp,f,fcco,cco,ucos,usin,arg,fdist,
     1xf,yf,zf,cfi,pi,xbox2,ybox2,zbox2,xmid,ymid,zmid
      logical lcyl
      pi=4.0d0*atan(1.0d0)
c     is this molecule the central one?:
      do 1 j=1,nper
      lcyl=lper(j).eq.init
1     if(lcyl)goto 2
2     if(lcyl)then
       f=1.0d0
      else
c      this molecule is not the central one, find distance:
       dist=fdist(irwp,rwp,nper,xmid,ymid,zmid,lper,x,y,z,icx)
c      find distance from the box walls:
       if(icx.eq.1)call dww(dw,yf,ybox2,zf,zbox2)
       if(icx.eq.2)call dww(dw,zf,zbox2,xf,xbox2)
       if(icx.eq.3)call dww(dw,xf,xbox2,yf,ybox2)
c      cut-off function:
       f=fcco(dist,cco,dist+dw)
      endif
c     rotate along 1D axis:
c     center, previous center, and all atoms:
      arg=cfi*pi/180.0d0*dble(it)*f
      usin=sin(arg)
      ucos=cos(arg)
      if(icx.eq.1)then
       call trb(yf       ,zf       ,ucos,usin)
       call trb(ymid     ,zmid     ,ucos,usin)
       do 5 j = init, stop
5      call trb(y(kmol(j)),z(kmol(j)),ucos,usin)
      endif
      if(icx.eq.2)then
       call trb(zf       ,xf       ,ucos,usin)
       call trb(zmid     ,xmid     ,ucos,usin)
       do 6 j = init, stop
6      call trb(z(kmol(j)),x(kmol(j)),ucos,usin)
      endif
      if(icx.eq.3)then
       call trb(xf       ,yf       ,ucos,usin)
       call trb(xmid     ,ymid     ,ucos,usin)
       do 7 j = init, stop
7      call trb(x(kmol(j)),y(kmol(j)),ucos,usin)
      endif
      return
      end
