c
c
c     ###################################################
c     ##  COPYRIGHT (C)  1990  by  Jay William Ponder  ##
c     ##              All Rights Reserved              ##
c     ###################################################
c
c     ##########################################################
c     ##                                                      ##
c     ##  subroutine atominmol  --  assign molecules to atoms ##
c     ##                                                      ##
c     ##########################################################
c
c
c     "molecule" counts the molecules, assigns each atom to
c     its molecule and computes the mass of each molecule
c
c
      subroutine atominmol
      implicit none
      include 'sizes.i'
      include 'atmtyp.i'
      include 'atoms.i'
      include 'couple.i'
      include 'molcul.i'
      include 'iounit.i'
      include 'atmolc.i'
      integer ia,im
c
c
      do 1 ia=1,n
      moat(ia)=0
      do 2 im=1,nmol
      if(ia.ge.imol(1,im).and.ia.le.imol(2,im))then
       moat(ia)=im
       goto 1
      endif
2     continue
      if(moat(ia).eq.0)then
       write(iout,30)ia
30     format(' atom ',i7,' does not have his molecule')
       call fatal
      endif
1     continue

      return
      end
