      subroutine imagea(xr,yr,zr,ia,x1,y1,z1,ib,x2,y2,z2)
c     adjusting for incremental twist of atom pairs
c     a, b close to the + wall  ... need to adjust for backwward shift
c     a, b close to the - wall  ... need to adjust for forward   shift
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cell.i'
      include 'cross.i'
      include 'rotc.i'
      real*8 xr,yr,zr,
     1xaa,yaa,zaa,x1(*),y1(*),z1(*),x2(*),y2(*),z2(*)
      integer ia,ib
c
      if (.not.orthogonal) then
       write(6,*)' Only orthogonal allowed for 1D periodicity'
       call fatal
      endif
      xr = x1(ia) - x2(ib)
      yr = y1(ia) - y2(ib)
      zr = z1(ia) - z2(ib)
      xaa=x1(ia)
      yaa=y1(ia)
      zaa=z1(ia)
      itx=0
      ity=0
      itz=0
c
c     fix the rotated axis first
      if(icx.eq.1)then
c      fix xr and xaa according to xr and record itx:
       call itit(itx,xr,xaa,xcell2,xcell)
c      rotate yaa,zaa, get new yr and zr:
       call rota(itx,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 yaa,zaa,yr,zr,y2(ib),z2(ib),cfi,ib,x1(ia),x2(ib),xcell2)
       call itit(ity,yr,yaa,ycell2,ycell)
       call itit(itz,zr,zaa,zcell2,zcell)
      endif

      if(icx.eq.2)then
       call itit(ity,yr,yaa,ycell2,ycell)
       call rota(ity,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 zaa,xaa,zr,xr,z2(ib),x2(ib),cfi,ib,y1(ia),y2(ib),ycell2)
       call itit(itz,zr,zaa,zcell2,zcell)
       call itit(itx,xr,xaa,xcell2,xcell)
      endif

      if(icx.eq.3)then
       call itit(itz,zr,zaa,zcell2,zcell)
       call rota(itz,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 xaa,yaa,xr,yr,x2(ib),y2(ib),cfi,ib,z1(ia),z2(ib),zcell2)
       call itit(itx,xr,xaa,xcell2,xcell)
       call itit(ity,yr,yaa,ycell2,ycell)
      endif

      return
      end
