      subroutine imagep(xr,yr,zr,ia,x1,y1,z1,ib,x2,y2,z2)
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cell.i'
      include 'atoms.i'
      include 'cross.i'
      include 'rotc.i'
      real*8 xr,yr,zr,pi,dd,dw,dist,fcco,
     1xro,yro,zro,
     1xaa,yaa,zaa,x1(*),y1(*),z1(*),x2(*),y2(*),z2(*)
      integer ia,ib,j
      logical lcyl
c
      pi=4.0d0*atan(1.0d0)
      if (.not.orthogonal) then
       write(6,*)' Only orthogonal allowed for 1D periodicity'
       call fatal
      endif
      xr = x1(ia) - x2(ib)
      yr = y1(ia) - y2(ib)
      zr = z1(ia) - z2(ib)
      xaa=x1(ia)
      yaa=y1(ia)
      zaa=z1(ia)
      itx=0
      ity=0
      itz=0
c
c     fix the rotated axis first
      if(icx.eq.1)then
       call itit(itx,xr,xaa,xcell2,xcell)
       call rott(irwp,rwp,itx,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 yaa,ycell2,zaa,zcell2,cco,yr,zr,y2(ib),z2(ib),cfi,icx,ib)
       call itit(ity,yr,yaa,ycell2,ycell)
       call itit(itz,zr,zaa,zcell2,zcell)
      endif

      if(icx.eq.2)then
       call itit(ity,yr,yaa,ycell2,ycell)
       call rott(irwp,rwp,ity,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 zaa,zcell2,xaa,xcell2,cco,zr,xr,z2(ib),x2(ib),cfi,icx,ib)
       call itit(itz,zr,zaa,zcell2,zcell)
       call itit(itx,xr,xaa,xcell2,xcell)
      endif

      if(icx.eq.3)then
       call itit(itz,zr,zaa,zcell2,zcell)
       call rott(irwp,rwp,itz,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 xaa,xcell2,yaa,ycell2,cco,xr,yr,x2(ib),y2(ib),cfi,icx,ib)
       call itit(itx,xr,xaa,xcell2,xcell)
       call itit(ity,yr,yaa,ycell2,ycell)
      endif

      return
      end
