      subroutine imageq(xr,yr,zr,ia,x1,y1,z1,x2,y2,z2)
      implicit none
      include 'sizes.i'
      include 'boxes.i'
      include 'cell.i'
      include 'cross.i'
      include 'atoms.i'
      real*8 xr,yr,zr,pi,dd,dw,dist,f,fcco,
     1xro,yro,zro,      
     1xaa,yaa,zaa,ucos,usin,x1(*),y1(*),z1(*),x2,y2,z2
      integer ia,j,itx,ity,itz
      logical lcyl
c
      pi=4.0d0*atan(1.0d0)
      if (.not.orthogonal) then
       write(6,*)' Only orthogonal allowed for 1D periodicity'
       call fatal
      endif
      xr = x1(ia) - x2
      yr = y1(ia) - y2
      zr = z1(ia) - z2
      xaa=x1(ia)
      yaa=y1(ia)
      zaa=z1(ia)
c
      itx=0
      ity=0
      itz=0
      if(icx.eq.1)then
       call itit(itx,xr,xaa,xcell2,xcell)
       call rott(irwp,rwp,itx,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 yaa,ycell2,zaa,zcell2,cco,yr,zr,y2,z2,cfi,icx)
       call itit(ity,yr,yaa,ycell2,ycell)
       call itit(itz,zr,zaa,zcell2,zcell)
      endif

      if(icx.eq.2)then
       call itit(ity,yr,yaa,ycell2,ycell)
       call rott(irwp,rwp,ity,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 zaa,zcell2,xaa,xcell2,cco,zr,xr,z2,x2,cfi,icx)
       call itit(itz,zr,zaa,zcell2,zcell)
       call itit(itx,xr,xaa,xcell2,xcell)
      endif

      if(icx.eq.3)then
       call itit(itz,zr,zaa,zcell2,zcell)
       call rott(irwp,rwp,itz,ia,nper,lper,xcell,ycell,zcell,x1,y1,z1,
     1 xaa,xcell2,yaa,ycell2,cco,xr,yr,x2,y2,cfi,icx)
       call itit(itx,xr,xaa,xcell2,xcell)
       call itit(ity,yr,yaa,ycell2,ycell)
      endif

      return
      end
